//+------------------------------------------------------------------+
//|                                                   HiLo range.mq4 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "brax64"
#property link      "http://www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 1

extern int    window        = 1;
extern int    corner        = 1;
extern int    xDistance     = 0;
extern int    yDistance     = 5;
extern color  text_color    = White;
extern int    text_size     = 9;
extern string text_font     = "Anonymous Pro Bold";
extern bool   Draw_targets  = true;
extern int    Stop_lines_at = 6;
extern color  upclr         = DodgerBlue;
extern color  dnclr         = Crimson;
extern color  opclr         = LimeGreen;
extern int    line_style    = 0;
extern int    line_width    = 2;

#define nobj  8

int    lookForLength, i, j, dig, mod, d1, d2, yofst, sl0, sl1, X, Y, start, stop;
double Op, Hi, Lo, ry, uptarget, dntarget, rt, dtop;
string id = "hilo_", lookFor, objectName, name, sym;
string text[nobj] = {"0", "1", "2", "3", "4", "5", "6", "7"};
string obj[nobj]  = {"yday", "tday", "open", "dtop", "prjh", "prhp", "prjl", "prlp"};
color  clr, doclr;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
{
   yofst = text_size * 1.5;
   sl0   = 26;
   sl1   = 5;
   dig   = MarketInfo(Symbol(),MODE_DIGITS);
   switch(dig)
   {
      case 2: mod = 100;    break;
      case 3: mod = 1000;   break;
      case 4: mod = 10000;  break;
      case 5: mod = 100000; break;
   }
   return(0);
}

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+

int deinit()
{
   lookFor       = id;
   lookForLength = StringLen(lookFor);
   for(i = ObjectsTotal() - 1; i >= 0; i--)
   {
      objectName = ObjectName(i);
      if(StringSubstr(objectName, 0, lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start()
{
   sym = Symbol();
   if(StringSubstr(sym, 0, 2) == "_t") sym = StringSubstr(sym,2);
   
   d1       = 0;      if(TimeDayOfWeek(iTime(sym, PERIOD_D1, d1)) == 1) d1++;
   d2       = d1 + 1; if(TimeDayOfWeek(iTime(sym, PERIOD_D1, d2)) == 0) d2++;
   
   Op       = iOpen(sym, PERIOD_D1, 0);
   Hi       = iHigh(sym, PERIOD_D1, d2);
   Lo       = iLow (sym, PERIOD_D1, d2);
      
   ry       = (Hi - Lo) * mod;
   uptarget = iLow(sym,PERIOD_D1,0) + (Hi - Lo);
   dntarget = iHigh(sym,PERIOD_D1,0) - (Hi - Lo);
   rt       = (iHigh(sym,PERIOD_D1,0) - iLow(sym,PERIOD_D1,0)) * mod;
   dtop     = MathAbs((iClose(sym,0,0) - Op) * mod);
   
   if(iClose(sym,0,0) - Op >  0) doclr = upclr;
   if(iClose(sym,0,0) - Op == 0) doclr = text_color;
   if(iClose(sym,0,0) - Op <  0) doclr = dnclr;

   text[0] = StringConcatenate("HiLo Yday : ", DoubleToStr(ry, 0));
   text[1] = StringConcatenate("HiLo Tday : ", DoubleToStr(rt, 0));
   text[2] = StringConcatenate("Open Tday : ", DoubleToStr(Op, dig));
   text[3] = DoubleToStr(dtop, 0);   
   text[4] = StringConcatenate("prj_HIGH  : ", DoubleToStr(uptarget, dig));
   text[5] = DoubleToStr((uptarget - iClose(sym,0,0)) * mod, 0);
   text[6] = StringConcatenate("prj_LOW   : ", DoubleToStr(dntarget, dig));
   text[7] = DoubleToStr((iClose(sym,0,0) - dntarget) * mod, 0);

   DrawLabels(i, j);

   if(Draw_targets)
   {
      DrawLines("up", uptarget, upclr, line_style, line_width);
      DrawLines("dn", dntarget, dnclr, line_style, line_width);
      DrawLines("op", Op,       opclr, line_style, line_width);
   }
      
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

void DrawLabels(int i, int j)
{
   for(i = 0; i <= 7; i++)
   {
      name = id + obj[i];
      
      ObjectCreate(name, OBJ_LABEL, window, 0, 0);
      ObjectSet   (name, OBJPROP_CORNER, corner);
      
      switch(i)
      {
         case 0: {Y = yDistance;             clr = text_color; j = sl0; break;}
         case 1: {Y = yDistance + yofst;                                break;}
         case 2: {Y = yDistance + yofst * 2; clr = opclr;               break;}
         case 3: {                           clr = doclr;      j = sl1; break;}
         case 4: {Y = yDistance + yofst * 3; clr = upclr;      j = sl0; break;}
         case 5: {                                             j = sl1; break;}
         case 6: {Y = yDistance + yofst * 4; clr = dnclr;      j = sl0; break;}
         case 7: {                                             j = sl1; break;}
      }
      
      ObjectSet    (name, OBJPROP_XDISTANCE, xDistance + 1);
      ObjectSet    (name, OBJPROP_YDISTANCE, Y);
      ObjectSetText(name, StringRightPad(text[i], j, " "), text_size, text_font, clr);
      
      if(corner == 0 || corner == 2)
      {
         sl0 = 0;
         sl1 = 24;
         ObjectSet    (name, OBJPROP_XDISTANCE, xDistance + 5);
         ObjectSetText(name, StringLeftPad(text[i], j, " "), text_size, text_font, clr);
      }
   }
   
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

void DrawLines(string text, double price, color Color, int style, int thickness)
{
   name  = id + text + " level";     
   start = Time[0] + Period() * 60 * 2;
   stop  = Time[0] + Period() * 60 * Stop_lines_at;
      
   if(ObjectFind(name) != 0)
   {
      ObjectCreate(name, OBJ_TREND, 0, start, price, stop, price);                            
      ObjectSet   (name, OBJPROP_STYLE, style);              
      ObjectSet   (name, OBJPROP_WIDTH, thickness);     
      ObjectSet   (name, OBJPROP_COLOR, Color);
      ObjectSet   (name, OBJPROP_RAY,   false);
   }            
   else
   {
      ObjectMove(name, 0, start, price);         
      ObjectMove(name, 1, stop,  price);
   }  
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

string StringRepeat(string str, int n = 1)
{
  string outstr = "";
  for(int i = 0; i < n; i++) outstr = outstr + str;
  return(outstr);
}

string StringRightPad(string str, int n = 1, string str2 = " ")
{
  return(str + StringRepeat(str2, n - StringLen(str)));
}

string StringLeftPad(string str, int n = 1, string str2 = " ")
{
  return(StringRepeat(str2, n - StringLen(str)) + str);
}